import { BirpcGroupReturn } from 'birpc';
import { A as AssetInfo, I as ImageMeta, V as ViteRPCFunctions, M as ModuleInfo } from '../types-1TEmpkcj.js';
import { ViteInspectAPI } from 'vite-plugin-inspect';

interface SetupAssetsOptions {
    root: string;
    base: string;
    server: any;
    getRpcServer: () => BirpcGroupReturn<ViteRPCFunctions>;
}
declare function setupAssetsRPC(config: SetupAssetsOptions): {
    getStaticAssets(): Promise<AssetInfo[]>;
    getImageMeta(filepath: string): Promise<ImageMeta | undefined>;
    getTextAssetContent(filepath: string, limit?: number | undefined): Promise<string | undefined>;
    assetsUpdated(): void;
};

interface SetupGraphOptions {
    rpc: ViteInspectAPI['rpc'];
    server: any;
    getRpcServer: () => BirpcGroupReturn<ViteRPCFunctions>;
}
declare function setupGraphRPC(options: SetupGraphOptions): {
    getGraph(): Promise<ModuleInfo[]>;
    moduleUpdated: () => void;
};

export { type SetupGraphOptions, setupAssetsRPC, setupGraphRPC };
